/*
 * Copyright 2016 Boshra Rajaei <b.rajaei@sadjad.ac.ir>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "prSAMP_Recovery.h"


int main(int argc, char *argv[])
{
  int i, j;
  double *p_prms, eps;
  double damp, vnf;
  double delta, *y;
  int *ir, *jc;
  int m, n, nnz; //nnz: number of non zero cells in X
  int disp, t_max;
  time_t t1, t2;
  char part[5] = "0";

  if(argc>1)
    strcpy(part, argv[1]);


  FILE *fp,*fp_w;
  char name[30] = "input";
  strcat(name, part);
  strcat(name, ".txt");
  fp = fopen(name, "r");


  readDimensions(fp, &m, &n, &nnz);

  p_prms = malloc(3 * sizeof *p_prms);
  ir = malloc(nnz*sizeof(*ir));
  jc = malloc((n+1)*sizeof(*jc));

  readFromText(fp, n, nnz, ir, jc, p_prms, &t_max, &eps, &damp, &vnf, &delta, &disp);

  complex double *a;

  y = malloc(m* sizeof(*y));
  readFromTextY(fp, m, y);
  fclose(fp);

  srand(time(NULL));
  gaussrand();
  complex double *x = malloc(n*sizeof(*x));
  for(j=0;j<n;j++)
     x[j] = gaussrand()*sqrt(1.0/n)+gaussrand()*sqrt(1.0/n)*I;

  cgamp(n, m, y, ir, jc, delta, p_prms,
                t_max, eps, damp, vnf, disp, x);

    char nameo[30] = "output";
    strcat(nameo, part);
    strcat(nameo, ".txt");
    fp_w = fopen(nameo, "w");
    writeRow(fp_w, n, x);
    fclose(fp_w);
    t2 = time(NULL);
    //printf("execution time: %d\n", t2-t1);

  return 0;
}
